<template>
  <div>
    <v-card class="pa-3">
      <p class="app-title">Add Data</p>
      <ValidationObserver ref="form" v-slot="{ handleSubmit }">
        <form @submit.prevent="handleSubmit(onSubmit)">
          <ValidationProvider v-slot="{ error }" name="Name" rules="required">
            <v-text-field
              label="Name"
              ref="name"
              :error-messages="error"
              placeholder="Euis"
              v-model="name"
            >
            </v-text-field>
          </ValidationProvider>
          <ValidationProvider
            v-slot="{ error }"
            name="Email"
            rules="required|email"
          >
            <v-text-field
              label="Email"
              :error-messages="error"
              placeholder="euis@gmail.com"
              v-model="email"
            >
            </v-text-field>
          </ValidationProvider>
          <ValidationProvider v-slot="{ error }" name="Amount" rules="">
            <v-select
              :items="listGrade"
              filled
              item-text="grade_name"
              item-value="id"
              :error-messages="error"
              label="Amount"
              v-model="amount"
            ></v-select>
            <!-- retun-object -->
          </ValidationProvider>
          <v-btn
            outlined
            block
            color="#f26525"
            type="submit"
            :loading="loading"
            class="mt-5"
            >Submit</v-btn
          >
        </form>
      </ValidationObserver>
    </v-card>
  </div>
</template>
<script>
import { createNamespacedHelpers } from "vuex";
const master = createNamespacedHelpers("master");
export default {
  data() {
    return {
      name: null,
      email: null,
      amount: null,
      formInput: [],
      loading: false,
      items: [
        {
          id: 1,
          name: "amount 1"
        },
        {
          id: 2,
          name: "amount 2"
        },
        {
          id: 3,
          name: "amount 3"
        }
      ]
    };
  },
  computed: {
    ...master.mapState(["listGrade"])
  },
  mounted() {
    this.$refs.name.focus();
    this.$store.dispatch("master/getGrade");
  },
  methods: {
    onSubmit() {
      this.loading = true;
      this.formInput = {
        name: this.name,
        email: this.email,
        amount: this.amount
      };
      this.$store.commit("data/SET_TEMPDATA", this.formInput);
      this.$store
        .dispatch("data/insertData")
        .then(response => {
          const res = response.data;
          const messagesSuccess = res.status.message;
          if (res.status) {
            this.loading = false;
            this.$swal
              .fire("Success!!", messagesSuccess, "success")
              .then(result => {
                if (result.isConfirmed) {
                  this.$router.push("/master-data");
                  // this.$router.go(-1) backto sebelumnya

                  // this.$router.go() backto sebelumnya
                }
              });
          }
        })
        .catch(error => {
          this.loading = false;
          const messagesError = error.response.data.status.message;
          this.$swal.fire("Error!!", messagesError, "error");
        });
    }
  }
};
</script>
